/*

Xiangqi Game

(C) Andrei Barbu 2003-2004

This software is distributed as is, under all the terms of the GPL.

*/

#include "player.h"

#ifndef __PIECE.H__
#define __PIECE.H__

#include "common.h"

int is_piece( int , int ); //Check if there is a player at row, col

enum piece_type { CANNON , CHARIOT , ELEPHANT , GUARD , KING , KNIGHT , PAWN }; // The types of pieces


class piece
{
    public:
	

        int x , y;
        piece_type type;
        SDL_Surface* surface;
        int flag[3];


/*
Flag Specifications:

Position        Values  Default Meaning
0               N/A     N/A     Unsued
1               0,1     0       Is it dead, 0 means no, 1 means yes
2               0,1     0       Only for pawns, it means they can now move sideways, set when crossing the river
3               N/A     N/A     Unused

*/

        piece() : x(0) , y(0) , type( CANNON ) , surface( new SDL_Surface )  { flag[1] = 0; flag[2] = 0; };
        piece( int xin , int yin , piece_type typein ) : x(xin) , y(yin) , type(typein) { flag[1] = 0; flag[2] = 0;};
        piece( int xin , int yin , piece_type typein , int flagin , SDL_Surface* surfacein ) : x(xin) , y(yin) , type(typein) , surface(surfacein) { flag[2] = flagin; };

        ~piece() {};

        void Set( int xin , int yin , piece_type typein ) { x = xin; y = yin; type = typein; }
        piece* Set_pt( int xin , int yin , piece_type typein ) { x = xin; y = yin; type = typein; flag[1] = 0; flag[2] = 0; return this; }
        void Set_surf( SDL_Surface *s ) { surface = s; }
        piece Setxy( int xin , int yin ) { x = xin; y = yin; return *this;}

	bool pawn_promote( int , int ); // Promote a pawn if it passes the river

        int p_valid_move( int , int , Turn );   // 0 on non valid, 1 on move is ok

        void p_print();                         // Print the piece out so we make debugging simpler
};


#endif
