/*

Xiangqi Game

(C) Andrei Barbu 2003-2004

This software is distributed as is, under all the terms of the GPL.

*/

#ifndef __PLAYER__
#define __PLAYER__

#include "engine.h"
#include "common.h"
#include "piece.h"


//using namespace std;

/*enum piece_type { CANNON , CHARIOT , ELEPHANT , GUARD , KING , KNIGHT , PAWN }; // The types of pieces

int is_piece( int , int ); //Check if there is a player at row, col


class piece
{
    public:

        int x , y;
        piece_type type;
        SDL_Surface* surface;
	int flag[3]; 


Flag Specifications:

Position	Values	Default Meaning
0		N/A	N/A	Unsued
1		0,1	0	Is it dead, 0 means no, 1 means yes
2		0,1	0	Only for pawns, it means they can now move sideways, set when crossing the river
3		N/A	N/A	Unused


	
	piece() : x(0) , y(0) , type( CANNON ) , surface( new SDL_Surface )  { flag[1] = 0; flag[2] = 0; };
        piece( int xin , int yin , piece_type typein ) : x(xin) , y(yin) , type(typein) { flag[1] = 0; flag[2] = 0;};
        piece( int xin , int yin , piece_type typein , int flagin , SDL_Surface* surfacein ) : x(xin) , y(yin) , type(typein) , surface(surfacein) { flag[2] = flagin; };

	~piece() {};

        void Set( int xin , int yin , piece_type typein ) { x = xin; y = yin; type = typein; }
        piece* Set_pt( int xin , int yin , piece_type typein ) { x = xin; y = yin; type = typein; flag[1] = 0; flag[2] = 0; return this; }
	void Set_surf( SDL_Surface *s ) { surface = s; }
	piece Setxy( int xin , int yin ) { x = xin; y = yin; return *this;}
	
	int p_valid_move( int , int , Turn );	// 0 on non valid, 1 on move is ok
	
	void p_print(); 			// Print the piece out so we make debugging simpler
};*/

class Player
{
    public:
	vector<char *> pieces_img;
	vector<piece *> pieces;


	Player( int x ); 				// 0 for red, 1 for black, all others get red
	Player() {}; 					// General constructor, use the above one preferrably 
	~Player() {};

	void print_pieces(); 				// printf to show a list of all pieces this player has

	int load_pieces();				// Loads a piece in
	int show_pieces( SDL_Surface* ); 		// Draw pieces on that surface

	bool is_piece( int , int ); 			// See if this player has a piece at row , col
	int is_piece_p( int , int ); 			// If the player has a piece there, return the index of that piece
	
	bool move( int , int , int , int , Turn ); 	// Move piece at ( row , col , destination row , dest col , turn )
							// Does not increment the turn
	
	Player* SetupBlack(); 				// Used internally to set the two colors up, sets pieces and their images to default
	Player* SetupRed();				// Ditto

	void ClearPlayer();				// Clears the player up
	
	int in_check( Turn );
	
	piece* king(); 					// Return a pointer to the king
							// Useful for implementing check functions and king - king line of sight
};

#endif


