/*

Xiangqi Game

(C) Andrei Barbu 2003-2004

This software is distributed as is, under all the terms of the GPL.

----

All the interfaces to this file are prefixed with SI_

*/

#ifndef __SDL_INTERFACE__
#define __SDL_INTERFACE__


#include <SDL/SDL.h>
#include <vector>
#include <SDL/SDL_image.h>
#include "player.h"
#include "main.h"
#include "common.h"

// Set SDL up
SDL_Surface * SI_Setup( int , int );
// Setup the board
SDL_Surface * SI_DrawBoard( int , int , SDL_Surface * );
// Rewdraw the board
void SI_ReDrawBoard( SDL_Surface * , int , int , SDL_Surface * );

// Convert x and y to board, row and col, and return a piece with the appropriate x and y values
piece SI_ConvertXY( int , int );

// Convert x and y screen coordinates to board coordinates ( row , col )
int SI_Row( int ); 
int SI_Col( int );

#endif

