/*

Xiangqi Game

(C) Andrei Barbu 2003-2004

This software is distributed as is, under all the terms of the GPL.

*/

#include "player.h"

// ---- Globals

extern Player* player[3]; //Let's get both players

// ---- 

Player::Player( int x )
{
    if( x == 1 ) 
	this->SetupBlack(); 
    else
    	this->SetupRed();
}

Player* Player::SetupBlack()
{
    pieces.push_back( new piece( 1 , 1 , CHARIOT ) );
    pieces.push_back( new piece( 9 , 1 , CHARIOT ) );
    pieces.push_back( new piece( 2 , 1 , KNIGHT ) );
    pieces.push_back( new piece( 8 , 1 , KNIGHT ) );
    pieces.push_back( new piece( 1 , 4 , PAWN ) );
    pieces.push_back( new piece( 3 , 4 , PAWN ) );    
    pieces.push_back( new piece( 5 , 4 , PAWN ) );    
    pieces.push_back( new piece( 7 , 4 , PAWN ) );    
    pieces.push_back( new piece( 9 , 4 , PAWN ) );    
    pieces.push_back( new piece( 2 , 3 , CANNON ) );    
    pieces.push_back( new piece( 8 , 3 , CANNON ) );    
    pieces.push_back( new piece( 3 , 1 , ELEPHANT ) );    
    pieces.push_back( new piece( 7 , 1 , ELEPHANT ) );    
    pieces.push_back( new piece( 5 , 1 , KING ) );    
    pieces.push_back( new piece( 4 , 1 , GUARD ) );    
    pieces.push_back( new piece( 6 , 1 , GUARD ) );
    
    pieces_img.push_back( "data/pieces/bcannon.gif" ); //I'd like to switch this to string, but IMG_Load fails
    pieces_img.push_back( "data/pieces/bchariot.gif");
    pieces_img.push_back( "data/pieces/belephant.gif");
    pieces_img.push_back( "data/pieces/bguard.gif");
    pieces_img.push_back( "data/pieces/bking.gif" );
    pieces_img.push_back( "data/pieces/bknight.gif" );
    pieces_img.push_back( "data/pieces/bpawn.gif" );
    
    return this;
}

Player* Player::SetupRed()
{

    pieces.push_back( new piece( 1 , 11 - 1 , CHARIOT ) );
    pieces.push_back( new piece( 9 , 11 - 1 , CHARIOT ) );
    pieces.push_back( new piece( 2 , 11 - 1 , KNIGHT ) );
    pieces.push_back( new piece( 8 , 11 - 1 , KNIGHT ) );
    pieces.push_back( new piece( 1 , 11 - 4 , PAWN ) );
    pieces.push_back( new piece( 3 , 11 - 4 , PAWN ) );
    pieces.push_back( new piece( 5 , 11 - 4 , PAWN ) );
    pieces.push_back( new piece( 7 , 11 - 4 , PAWN ) );
    pieces.push_back( new piece( 9 , 11 - 4 , PAWN ) );
    pieces.push_back( new piece( 2 , 11 - 3 , CANNON ) );
    pieces.push_back( new piece( 8 , 11 - 3 , CANNON ) );
    pieces.push_back( new piece( 3 , 11 - 1 , ELEPHANT ) );
    pieces.push_back( new piece( 7 , 11 - 1 , ELEPHANT ) );
    pieces.push_back( new piece( 5 , 11 - 1 , KING ) );
    pieces.push_back( new piece( 4 , 11 - 1 , GUARD ) );
    pieces.push_back( new piece( 6 , 11 - 1 , GUARD ) );
    
    pieces_img.push_back( "data/pieces/rcannon.gif" );
    pieces_img.push_back( "data/pieces/rchariot.gif" );
    pieces_img.push_back( "data/pieces/relephant.gif" );
    pieces_img.push_back( "data/pieces/rguard.gif" );
    pieces_img.push_back( "data/pieces/rking.gif" );
    pieces_img.push_back( "data/pieces/rknight.gif" );
    pieces_img.push_back( "data/pieces/rpawn.gif" );
    
    return this;
}

void Player::ClearPlayer()
{
    while( !pieces.empty() )
	pieces.pop_back();
    while( !pieces_img.empty() )
	pieces_img.pop_back();
}

void Player::print_pieces()
{
    for( unsigned int i = 0; i < pieces.size(); i++ )
	PDEBUG("Iterator: %d , %d , %d\n",  pieces[i]->x , pieces[i]->y , pieces[i]->type );
}

int Player::load_pieces()
{
    for( unsigned int i = 0; i < pieces.size(); i++ )
    {
	switch ( pieces[i]->type ) 
	{
	    case CANNON: 
		pieces[i]->surface = IMG_Load( pieces_img[0] ); break;
	    case CHARIOT: 
		pieces[i]->surface = IMG_Load( pieces_img[1] ); break;
	    case ELEPHANT: 
		pieces[i]->surface = IMG_Load( pieces_img[2] ); break;
	    case GUARD: 
	    	pieces[i]->surface = IMG_Load( pieces_img[3] ); break;
	    case KING: 
		pieces[i]->surface = IMG_Load( pieces_img[4] ); break;
	    case KNIGHT: 
		pieces[i]->surface = IMG_Load( pieces_img[5] ); break;
	    case PAWN: 
		pieces[i]->surface = IMG_Load( pieces_img[6] ); break;
	    default: return 1;    
	}
    }
    for( unsigned int i = 0; i < pieces.size(); i++ )
	if( pieces[i]->surface == NULL )
	    return 1;
    return 0;
}

int Player::show_pieces( SDL_Surface *screen )
{
    SDL_Rect dest, src; 
    
    src.y = 0;
    src.x = 0;
    Uint32 colorkey = SDL_MapRGB( screen->format , 0 , 0 , 0 );

    for( unsigned int i = 0; i < pieces.size(); i++ )
    {
	
	SDL_SetColorKey( pieces[i]->surface , SDL_SRCCOLORKEY , colorkey );
	src.h = pieces[i]->surface->h;
	src.w = pieces[i]->surface->w;
	dest.x =  - (int)( pieces[i]->surface->h / 2 ) + 215 + ( pieces[i]->x * 67 ); //Make them centered correctly
	dest.y =  - (int)( pieces[i]->surface->w / 2 ) + ( pieces[i]->y * 65 ) + 35 ;
	dest.h = pieces[i]->surface->h;
	dest.w = pieces[i]->surface->w;
	SDL_BlitSurface( pieces[i]->surface , &src, screen , &dest );
    }
    
    SDL_UpdateRect( screen , 0 , 0 , 0 , 0 );
    
    return 0;
}

// Is there a piece at row , col?
bool Player::is_piece( int row , int col ) 
{
    for( unsigned i = 0; i < pieces.size(); i++ )
	if( pieces[i]->x == row && pieces[i]->y == col )
	    return true;
    return false;
}

// Is there a piece at row, col, I should fix this to do what it's supposed to, return a pointer to the piece
int Player::is_piece_p( int row , int col )
{
    for( unsigned i = 0; i < pieces.size(); i++ )
	if( pieces[i]->x == row && pieces[i]->y == col )
	    return i;
    return -1;
}

bool Player::move( int sx , int sy , int dx , int dy , Turn turn ) // True on move, false on no move
{    
    if( !turn.valid() )  //Let's save a little time by bailing out if there is no turn, p_valid_move would have failed anyway
	return false;
	
    for( unsigned i = 0; i < pieces.size(); i++ )
	if( pieces[i]->x == sx && pieces[i]->y == sy )
	    if( pieces[i]->p_valid_move( dx , dy , turn ) )
	    {

		pieces[i]->pawn_promote( dx , dy ); // If it's a pawn and it crosses 5 & 6 promote it

		pieces[i]->p_print(); // Debug message, eventually it'll be removed when I'm confortable that this works correctly

		pieces[i]->Setxy( dx , dy ); // The actual move
		
//		++turn; // Next turn
		
		
		if( player[turn.curr()]->in_check( turn ) ) // If this move puts us in check, it isn't allowed
		{
		    pieces[i]->Setxy( sx , sy ); // So we move back
		    
		    return true;
		    
		}
		else
		{
		    ++turn;
		    if( player[turn.curr()]->is_piece( dx , dy ) ) // Let's see if we are capturing anything
			player[turn.curr()]->pieces.erase( player[turn.curr()]->pieces.begin() + player[turn.curr()]->is_piece_p( dx , dy ) ); 
			// Remove it from the container
		    
		    return true;

		}
	    }
    return false; // Just to appease gcc and surpress a warning, it'll never get here
}

int Player::in_check( Turn turn )
{
    if( !turn.valid() ) // Turn is invalid, so we might as well say yeah, sure, you're in check, go away now
    	return 1;
				
    piece* myking = player[turn.curr()]->king();
    
    ++turn; // We're incrementing the turn to see if the next turn our king can be captured
    
    // Normal checking if we are in check
    for( unsigned int i = 0; i < player[turn.curr()]->pieces.size(); i++ )
	if( (player[turn.curr()]->pieces[i])->p_valid_move( myking->x , myking->y , turn ) )
	{
	    PDEBUG("Check!\n");
	    return 1;
	}

    return 0;
}

// Pointer to the king

piece* Player::king()
{
    for( unsigned int i = 0; i < pieces.size(); i++ )
	if( pieces[i]->type == KING )
	    return pieces[i];
	    
    printf( "Player! doesn't have a king!!\n" );
    printf( "We're gonna segfault soon!\n") ;
    return NULL; // Isn't required since a player will always have a king, but keeps gcc from issuing an error
}

