/*

Xiangqi Game

(C) Andrei Barbu 2003-2004

This software is distributed as is, under all the terms of the GPL.

*/

#include "sdl_interface.h"


SDL_Surface *SI_Setup( int x , int y )
{
    SDL_Surface *screen;
    
    if( SDL_Init ( SDL_INIT_VIDEO ) != 0 )
    {
	printf("Error in SDL_Init: %s\n" , SDL_GetError() );
	return NULL;
    }
    
    if( (screen = SDL_SetVideoMode( x , y , 16 , 0 )) == NULL )
    {
	printf("Error in SDL_SetVideoMode: %s\n" , SDL_GetError() );
	return NULL;
    }

    SDL_WM_SetCaption("Xiangqi - The Game", "Xiangqi");
    
    return screen;
}


SDL_Surface *SI_DrawBoard( int x , int y , SDL_Surface* screen )
{
    SDL_Surface *img = IMG_Load("data/images/board.png");
    SDL_Rect dest , src;
    
    if( img == NULL )
    {
	printf("Error loading the board: %s\n" , IMG_GetError());
	return NULL;
    }
    
    src.w = img->w;
    src.h = img->h;
    src.x = 0;
    src.y = 0;
    
    dest.w = src.w;
    dest.h = src.h;
    dest.x = x;
    dest.y = y;

    SDL_BlitSurface(img , &src , screen , &dest );
    
    return img;
}

void SI_ReDrawBoard( SDL_Surface* img , int x , int y , SDL_Surface* screen )
{
    SDL_Rect dest , src;
    
    src.w = img->w;
    src.h = img->h;
    src.x = 0;
    src.y = 0;
    
    dest.w = src.w;
    dest.h = src.h;
    dest.x = x;
    dest.y = y;

    SDL_BlitSurface(img , &src , screen , &dest );
}

piece SI_ConvertXY( int xval , int yval )
{
    piece tmp_piece;
    
    printf( "Xval (%i) , Yval (%i) \n " , xval , yval );
    
    for( int col = 1; col < 10; col++ )
    {
	if( ((col * 67 + (282 - 67)) - xval ) < 20 && ((col * 67 + (282 - 67)) - xval ) > -20 )
	{
	    printf( "col is (%i) \n", col );

	    for( int row = 0; row < 11; row++ )
		if( ((row * 65 + (101 - 65)) - yval) < 20 && ((row * 65 + (101-66)) - yval) > - 20 )
		    return (tmp_piece.Setxy( col , row ));
	}	    
	    
    }
    tmp_piece.Setxy( 0 , 0 );
    return tmp_piece;
}

int SI_Row( int xval )
{
    for( int col = 1; col < 10; col++ )
	if( abs( (col * 67 + (282 - 67)) - xval ) < 33 )
	    return col;
	    
    return -1;

}

int SI_Col( int yval )
{
    for( int row = 0; row < 11; row++ )
	if( abs( (row * 65 + (101 - 65)) - yval ) < 33 )
	    return row;
	    
    return -1;
}

